Skip to content
Get started

Lookup user lending distribution by asset

GET/api/v1/users/{address}/markets/lend/lookup

Lookup user lending distribution by asset

Path ParametersExpand Collapse
address: string

The user account address

Query ParametersExpand Collapse
asset_id: string

Asset ID for lookup

with_text: optional boolean

Include text variation fields

with_value: optional boolean

Calculate and include USD values for amounts, where applicable

ReturnsExpand Collapse
data: UserLendAssetPool { asset_info, market_rate, origin_equivalent, receipt_amounts }
asset_info: AssetInfo { asset, classification, metadata }

Asset identifiers with associated metadata

asset: AssetSpec { id, group, group_key }

Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc)

id: string
group: "native" or "token"
One of the following:
"native"
"token"
group_key: string
classification: AssetClassification

The asset's classification metadata. Assets are classfied to provide context on their usage throughout the Neptune API (e.g. regular assets, neptune receipt tokens, LSTs, etc.)

Each asset belongs to only a single classification type. This object contains metadata pertaining to the given classification.

While some fields may be common among the distinct classifcations, each classification is distinct and subject to independent change.

One of the following:
Regular = object { kind, neptune_receipt_asset }
kind: "regular"
neptune_receipt_asset: AssetSpec { id, group, group_key }

Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc)

id: string
group: "native" or "token"
One of the following:
"native"
"token"
group_key: string
NeptuneReceiptToken = object { kind, origin_asset }
kind: "neptune_receipt_token"
origin_asset: AssetSpec { id, group, group_key }

Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc)

id: string
group: "native" or "token"
One of the following:
"native"
"token"
group_key: string
LiquidStakingToken = object { kind, origin_asset }
kind: "liquid_staking_token"
origin_asset: AssetSpec { id, group, group_key }

Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc)

id: string
group: "native" or "token"
One of the following:
"native"
"token"
group_key: string
metadata: AssetMetadata { decimals_denom, decimals_display, name, 2 more }

Additional metadata for assets

decimals_denom: number

Denom exponent, or num. of decimal places that shift between denom/standard amounts (e.g. 18 for INJ)

formatuint32
minimum0
decimals_display: number

Number of decimals used when displaying amounts of this asset (this is subjective and used for generating text representations)

formatuint32
minimum0
name: string

Full name of the asset

symbol: string

Symbol of the asset, e.g.: NEPT INJ

symbol_denom: string

Denom symbol for the asset (e.g. inj for INJ, sat for BTC)

market_rate: MarketRate { apr, apy, extra }

Current market lending rate

apr: string

Market rate in APR standard as a decimal percentage

apy: string

Market rate in APY standard as a decimal percentage

extra: object { text }
text: object { apr, apy }

Human-readable field variants. Will not be null when query param with_text is true.

apr: string
apy: string
origin_equivalent: UserLendOriginAmounts { collateralized, extra, held, total }

The lending amounts converted into the equivalent for the receipt token's origin/source asset

collateralized: string

Total equivalent amount of origin token collateralized across this user's borrowing portfolio

NOTE: This is not the amount of the origin asset that the user holds, but the amount held in the receipt token rendered as the equivalent amount in the origin asset.

Or, more formally: origin_equivalent_collateralized = receipt_collateralized / receipt_redemption_ratio

extra: object { text }
text: object { collateralized, held, total }

Human-readable field variants. Will not be null when query param with_text is true.

collateralized: string
held: string
total: string
held: string

Total equivalent amount of origin token held in address balance

NOTE: This is not the amount of the origin asset that the user holds, but the amount held in the receipt token rendered as the equivalent amount in the origin asset.

Or, more formally: origin_equivalent_held = receipt_held / receipt_redemption_ratio

total: string

Total of held and collateralized equivalent for origin asset

Or, more formally: origin_equivalent_total = receipt_lent_total / receipt_redemption_ratio

receipt_amounts: UserLendReceiptAmounts { collateralized, extra, held, total }

The lending amounts in the original receipt token amounts

collateralized: string

Total amount of receipt token collateralized across this user's borrowing portfolio

extra: object { text, value }
text: object { collateralized, held, total }

Human-readable field variants. Will not be null when query param with_text is true.

collateralized: string
held: string
total: string
value: object { collateralized, extra, held, 2 more }

USD values for the corresponding amounts above. Will not be null when query param with_value is true.

Note

This variant group contains an additional price field (set to the number used in value calculation).

The embedded text group will contain the text variant if with_text was specified as well.

collateralized: string
extra: object { text }
text: object { collateralized, held, price, total }

Human-readable variants of USD values. Will not be null when query params with_text and with_value are true.

collateralized: string
held: string
price: string

Text representation of price

total: string
held: string
price: string

Price used in value calculations

total: string
held: string

Total amount of receipt token held in address balance

total: string

Sum of receipt amount held and receipt amount collateralized

error: unknown

Error data. Guaranteed null for successful response.

status: number

HTTP status. Successful responses are guaranteed to be < 400. Conversely, error responses are guaranteed to be >= 400.

formatuint16
minimum0
maximum65535
status_text: string

HTTP status text

Lookup user lending distribution by asset

curl https://api-v2.nept.finance/api/v1/users/$ADDRESS/markets/lend/lookup
{
  "data": {
    "asset_info": {
      "asset": {
        "id": "native;inj",
        "group": "native",
        "group_key": "inj"
      },
      "metadata": {
        "name": "Injective",
        "symbol": "INJ",
        "symbol_denom": "inj",
        "decimals_denom": 18,
        "decimals_display": 4
      },
      "classification": {
        "kind": "regular",
        "neptune_receipt_asset": {
          "id": "token;inj1rmzufd7h09sqfrre5dtvu5d09ta7c0t4jzkr2f",
          "group": "token",
          "group_key": "inj1rmzufd7h09sqfrre5dtvu5d09ta7c0t4jzkr2f"
        }
      }
    },
    "market_rate": {
      "apr": "0.25122284",
      "apy": "0.28559653",
      "extra": {
        "text": {
          "apy": "28.55%",
          "apr": "25.12%"
        }
      }
    },
    "receipt_amounts": {
      "held": "34390327811707579753",
      "collateralized": "905248963117284075569",
      "total": "939639290928991655322",
      "extra": {
        "text": {
          "total": "939.6392 nINJ",
          "held": "34.3903 nINJ",
          "collateralized": "905.2489 nINJ"
        },
        "value": {
          "held": "110.889355961626261527",
          "collateralized": "2918.915895615050113165",
          "price": "3.224434398205298254",
          "total": "3029.805251576676374692",
          "extra": {
            "text": {
              "price": "$3.22",
              "collateralized": "$2,918.91",
              "held": "$110.88",
              "total": "$3,029.80"
            }
          }
        }
      }
    },
    "origin_equivalent": {
      "held": "36884382073374002120",
      "collateralized": "970899399678786249629",
      "total": "1007783781752160251749",
      "extra": {
        "text": {
          "total": "1,007.7837 INJ",
          "collateralized": "970.8993 INJ",
          "held": "36.8843 INJ"
        }
      }
    }
  },
  "error": null,
  "status": 200,
  "status_text": "200 OK"
}
{
  "data": null,
  "error": {
    "kind": "internal",
    "scope": "server",
    "message": "An unexpected error occurred"
  },
  "status": 500,
  "status_text": "500 Internal Server Error"
}
Returns Examples
{
  "data": {
    "asset_info": {
      "asset": {
        "id": "native;inj",
        "group": "native",
        "group_key": "inj"
      },
      "metadata": {
        "name": "Injective",
        "symbol": "INJ",
        "symbol_denom": "inj",
        "decimals_denom": 18,
        "decimals_display": 4
      },
      "classification": {
        "kind": "regular",
        "neptune_receipt_asset": {
          "id": "token;inj1rmzufd7h09sqfrre5dtvu5d09ta7c0t4jzkr2f",
          "group": "token",
          "group_key": "inj1rmzufd7h09sqfrre5dtvu5d09ta7c0t4jzkr2f"
        }
      }
    },
    "market_rate": {
      "apr": "0.25122284",
      "apy": "0.28559653",
      "extra": {
        "text": {
          "apy": "28.55%",
          "apr": "25.12%"
        }
      }
    },
    "receipt_amounts": {
      "held": "34390327811707579753",
      "collateralized": "905248963117284075569",
      "total": "939639290928991655322",
      "extra": {
        "text": {
          "total": "939.6392 nINJ",
          "held": "34.3903 nINJ",
          "collateralized": "905.2489 nINJ"
        },
        "value": {
          "held": "110.889355961626261527",
          "collateralized": "2918.915895615050113165",
          "price": "3.224434398205298254",
          "total": "3029.805251576676374692",
          "extra": {
            "text": {
              "price": "$3.22",
              "collateralized": "$2,918.91",
              "held": "$110.88",
              "total": "$3,029.80"
            }
          }
        }
      }
    },
    "origin_equivalent": {
      "held": "36884382073374002120",
      "collateralized": "970899399678786249629",
      "total": "1007783781752160251749",
      "extra": {
        "text": {
          "total": "1,007.7837 INJ",
          "collateralized": "970.8993 INJ",
          "held": "36.8843 INJ"
        }
      }
    }
  },
  "error": null,
  "status": 200,
  "status_text": "200 OK"
}
{
  "data": null,
  "error": {
    "kind": "internal",
    "scope": "server",
    "message": "An unexpected error occurred"
  },
  "status": 500,
  "status_text": "500 Internal Server Error"
}